
# NodeGraphQt

<p align="center">
    <a href="https://jchanvfx.github.io/NodeGraphQt" target="_blank">
    <img src="https://raw.githubusercontent.com/jchanvfx/NodeGraphQt/main/docs/_images/logo.png" title="logo">
    </a>
</p>

NodeGraphQt is a node graph UI framework for `PySide2` that can be implemented and re-purposed into 
applications.

<img src="https://raw.githubusercontent.com/jchanvfx/NodeGraphQt/main/docs/_images/screenshot.png" width="100%" title="NodeGraphQt">

## Install

NodeGraphQt is available on The Python Package Index (PyPI) [here](https://pypi.org/project/NodeGraphQt) so it can be installed with:
```
pip install NodeGraphQt
```
or you can download previous versions from the [releases](https://github.com/jchanvfx/NodeGraphQt/releases) page.


## Documentation

<a href="https://jchanvfx.github.io/NodeGraphQt" target="_blank">https://jchanvfx.github.io/NodeGraphQt</a>

See the [basic_example.py](/examples/basic_example.py) script to get started or check out the API example overview 
<a href="https://jchanvfx.github.io/NodeGraphQt/api/html/examples/ex_overview.html#simple-example" target="_blank">here.</a>

## Vertical Layout

https://jchanvfx.github.io/NodeGraphQt/api/html/examples/ex_pipe.html#layout-direction

<img src="https://raw.githubusercontent.com/jchanvfx/NodeGraphQt/main/docs/_images/vertical_layout.png" width="800" title="Vertical Layout">

## Pipe Layout

https://jchanvfx.github.io/NodeGraphQt/api/html/examples/ex_pipe.html#layout-styles

<img src="https://raw.githubusercontent.com/jchanvfx/NodeGraphQt/main/docs/_images/pipe_layout_types.gif" width="600" title="Pipe Layout">

## Custom Widgets

https://jchanvfx.github.io/NodeGraphQt/api/html/custom_widgets.html

<img src="https://raw.githubusercontent.com/jchanvfx/NodeGraphQt/main/docs/_images/prop_bin.png" width="600" title="Properties Bin">

<img src="https://raw.githubusercontent.com/jchanvfx/NodeGraphQt/main/docs/_images/nodes_palette.png" width="450" title="Node Palette">
